﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;
using Syncfusion.XForms.PopupLayout;
using System.Globalization;
using System.Runtime.CompilerServices;

namespace TextInput
{
    // Learn more about making custom code visible in the Xamarin.Forms previewer
    // by visiting https://aka.ms/xamarinforms-previewer
    [DesignTimeVisible(true)]
    public partial class MainPage : ContentPage
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void GestureRecognizer_Tapped(object sender, System.EventArgs e)
        {
            popupLayout.IsOpen = true;
            popupLayout.Focus();
        }

        void Handle_ItemSelected(object sender, Xamarin.Forms.SelectedItemChangedEventArgs e)
        {
            viewModel.MonthName = (e.SelectedItem as Model).Name;
            popupLayout.IsOpen = false;
        }
    }

    public class ViewModel : INotifyPropertyChanged
    {
        public ObservableCollection<Model> NamesList { get; set; }

        public event PropertyChangedEventHandler PropertyChanged;

        private string monthName;

        public string MonthName
        {
            get { return monthName; }
            set
            {
                monthName = value;
                NotifyPropertyChanged();
            }
        }

        public ViewModel()
        {
            NamesList = new ObservableCollection<Model>()
            {
               new Model(){ Name = "January" },
                new Model(){ Name = "February" },
                 new Model(){ Name = "March" },
                  new Model(){ Name = "April" },
                   new Model(){ Name = "May" },
            }; 
        }

        private void NotifyPropertyChanged([CallerMemberName] String propertyName = "")
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }

    public class Model: INotifyPropertyChanged
    {
        private string name;

        public string Name
        {
            get { return name; }
            set
            {
                name = value;
                NotifyPropertyChanged();
            } 
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged([CallerMemberName] String propertyName = "")
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }

}
